function out=wgme_cv(mu,nn,z,N,kk2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code is used in Wu, X, A Weighted Generalized Maximum Entropy Estimator with a Data-driven Weight, Entropy, forthcoming.
% It implements the monte carlo simulation for the case where error term is normally distributied
% author: Ximing Wu
% this version: Dec. 28, 2009
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

M=4;
out=zeros(N,3*M+2);



a=[sqrt(2/(1+mu)),1,1,sqrt(2*mu/(1+mu))];
beta0=[2 1 -3 2];


for i=1:N
	x=normrnd(0,1,nn,M);
	[u,s,v]=svd(x);

	s(1:M,1:M)=diag(a);

	x=u*s*v';

	y=x*beta0'+normrnd(0,1,nn,1);

	
	t=x\y;
	out(i,1:(M))=t';

	
	res=y-x*t;
	ss=std(y);

	tt=zeros(1,length(kk2));
	

		for k2=1:length(kk2)
			dtt=zeros(nn,1);
			for j=1:nn
				yy=y;
				xx=x;
				yy(j)=[];
				xx(j,:)=[];
				t=xx\yy;
				res=yy-xx*t;
				ss=std(res);
				fit=gme_w(yy,xx,repmat([-z -z/2 0 z/2 z],M,1),[-ss -ss/2 0 ss/2 ss]*3,kk2(k2));
				dtt(j)=(y(j)-x(j,:)*fit)^2;
			end
			dtt=dtt(isnan(dtt)==0);
			
			if length(dtt)<nn/2
				tt(k2)=10^6;
			end
			
			if length(dtt)>nn/2
				tt(k2)=mean(dtt);
			end		
				

	end				
	

	k22=kk2(tt==min(tt));
	
	k22=k22(1);
	
	t=x\y;
	res=y-x*t;
	ss=std(res);

	fit=gme_w(y,x,repmat([-z -z/2 0 z/2 z],M,1),[-ss -ss/2 0 ss/2 ss]*3,k22);
	out(i,(M+1):(2*M))=fit';

	fit=gme(y,x,repmat([-z -z/2 z/2 0 z],M,1),[-ss -ss/2 0 ss/2 ss]*3);
	out(i,(2*M+1):3*M)=fit';

	out(i,3*M+1:end)=[ss  k22];

end				